#import <Foundation/Foundation.h>
#include <unistd.h>
#include <signal.h>

@interface Test : NSObject
- helloThere: (NSTimer *)aTimer;
@end

@implementation Test
- helloThere: (NSTimer *)aTimer
{
	NSLog(@"Hello!");
}
@end

BOOL done = NO;

void signal_handler(int a)
{
	done = YES;
}

int main(int argc, char **argv, char **env)
{
	id timer;
	id object = [Test new];
	
	CREATE_AUTORELEASE_POOL(arp);
	signal(SIGINT, signal_handler);
	
	timer = RETAIN([NSTimer scheduledTimerWithTimeInterval: 1.0
	  target: object
	  selector: @selector(helloThere:)
	  userInfo: nil
	  repeats: YES]);
	while (!done)
	{
		[[NSRunLoop currentRunLoop] runUntilDate: [NSDate dateWithTimeIntervalSinceNow: 1]];
	}
	[timer invalidate];
	RELEASE(timer);
	RELEASE(object);
	RELEASE(arp);
	return 0;
}

	
	
